require 'require_all'
require_rel 'tessitura_rest'
require 'json'
require 'httparty'

class TessituraRest
  include HTTParty

  include Accounts
  include Actions
  include Addresses
  include Attributes
  include Appeals
  include BillingSchedules
  include Cart
  include Constituencies
  include Constituents
  include Countries
  include Diagnostics
  include Email
  include GiftCertificates
  include Issues
  include LocalProcedure
  include Login
  include Orders
  include Package
  include Payments
  include PaymentPlanExtension
  include PerformanceExtension
  include PerformancePackageModeOfSales
  include Phones
  include PriceTypes
  include ProductionExtension
  include ProductKeywords
  include ProductionSeason
  include Registration
  include Sections
  include Session
  include SecurityUserGroups
  include States
  include SubLineItems
  include WebContents
  include WebLogins

  def initialize(options={})
    @auth = { username: ENV['TESSITURA_USERNAME'],
              password: ENV['TESSITURA_PASSWORD'] }
    @headers = { 'Accept': 'application/json' }
  end

  def base_api_endpoint(end_point)
    "#{ENV['TESSITURA_URL']}#{end_point}"
  end

end
