module Issues

  def get_issue(id, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("CRM/Issues/#{id}"), options)
    JSON.parse(response.body)
  end

  def get_issues(constituent_id, start_date = Date.today, end_date = Date.today + 365, resolved = false, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("CRM/Issues?constituentId=#{constituent_id}"), options)
    JSON.parse(response.body)
  end

  def create_issue(activity_type, category_id, constituent_id, contact_type, notes, origin_id, options={})
    parameters =
    {
      'ActivityType': {
        'Id': activity_type,
        'Category': {
          'Id': category_id
        }
      },
      'ContactType': {
        'Id': contact_type
      },
      'Constituent': {
        'Id': constituent_id
      },
      "Origin": {
        "Id": origin_id
      },
      'Notes': notes
    }
    parameters.delete(:Origin) unless origin_id.present?
    options.merge!(basic_auth: @auth, headers: @headers)
    options.merge!(:body => parameters)
    response = self.class.post(base_api_endpoint('CRM/Issues'), options)
    JSON.parse(response.body)
  end

end
