module LocalProcedure

  def execute_local_procedure(id, params = "", options={})
    parameters =
      {
          'ProcedureId' => id.to_s,
          'Parameters' => params
      }
    options.merge!(basic_auth: @auth, headers: @headers)
    options.merge!(:body => parameters.to_json, :headers => {'Content-Type' => 'application/json'})
    self.class.post(base_api_endpoint('Custom/Execute'), options)
  end

  def execute_local_procedure_v2(id, params = [], options={})
    parameters =
      {
          'ProcedureId' => id.to_s,
          'ParameterValues' => params
      }
    options.merge!(basic_auth: @auth, headers: @headers)
    options.merge!(:body => parameters.to_json, :headers => {'Content-Type' => 'application/json'})
    self.class.post(base_api_endpoint('Custom/Execute'), options)
  end

  def execute_local_procedure_with_multiple_result_sets(id, parameter_values= [], options={})
    parameters =
      {
          'ProcedureId' => id.to_s,
          'ParameterValues' => parameter_values
      }
    options.merge!(basic_auth: @auth, headers: @headers)
    options.merge!(:body => parameters.to_json, :headers => {'Content-Type' => 'application/json'})
    self.class.post(base_api_endpoint('Custom/Execute/MultipleResultSets'), options)
  end
end
