module Package

  def get_package_by_id(id, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("TXN/Packages/#{id}"), options)
    JSON.parse(response.body)
  end

  def packages_by_performance_date(start_date=nil, end_date=nil, options={})
    parameters =
      {
        'PerformanceStartDate': start_date,
        'PerformanceEndDate': end_date
      }
    options.merge!(basic_auth: @auth, headers: @headers)
    options.merge!(:body => parameters)
    response = self.class.post(base_api_endpoint('TXN/Packages/Search'), options)

  end

  def get_package_detail(id, mode_of_sale, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("TXN/Packages/#{id}/Details?modeOfSaleId=#{mode_of_sale}"), options)
    JSON.parse(response.body)
  end

  def get_package_prices(id, mode_of_sale, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("TXN/Packages/#{id}/Prices?modeOfSaleId=#{mode_of_sale}"), options)
    JSON.parse(response.body)
  end

  def get_package_performance_groups(id, mode_of_sale=nil, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("TXN/Packages/#{id}/PerformanceGroups?modeOfSaleId=#{mode_of_sale}"), options)
    JSON.parse(response.body)
  end

  def get_package_seat_summaries(id, mode_of_sale, constituent_id, price_type_ids, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("TXN/Packages/#{id}/Seats/Summary?modeOfSaleId=#{mode_of_sale}&constituentId=#{constituent_id}&checkPriceTypeIds=#{price_type_ids}"), options)
    JSON.parse(response.body)
  end

  def get_package_seats(id, mode_of_sale, constituent_id, section_id, options={})
    options.merge!(basic_auth: @auth, headers: @headers)
    response = self.class.get(base_api_endpoint("TXN/Packages/#{id}/Seats?modeOfSaleId=#{mode_of_sale}&constituentId=#{constituent_id}&sectionIds=#{section_id}"), options)
    JSON.parse(response.body)
  end
end
